routes/admin.php
<?php

Route::get('/', 'HomeController@index')->name('dashboard');

Route::get('/department/data', 'DataController@departments')->name('department.data');
Route::resource('/department', 'DepartmentController');

Route::get('/position/data', 'DataController@positions')->name('position.data');
Route::resource('position', 'PositionController');

Route::get('/group/data', 'DataController@groups')->name('group.data');
Route::resource('group', 'GroupController');

Route::get('/employee/data', 'DataController@employees')->name('employee.data');
Route::resource('employee', 'EmployeeController');
Route::get('/employee/{id}/addcontract', function(){return "add contract page";})->name('employee.addcontract');

Route::get('/user/data', 'DataController@users')->name('user.data');
Route::resource('user', 'UserController');
Route::get('/useremployee', 'UserController@indexEmployee')->name('user.employee');

Route::get('/attendance/data', 'DataController@attendances')->name('attendance.data');
Route::resource('attendance', 'AttendanceController');

Route::get('/complain/data', 'DataController@complains')->name('complain.data');
Route::resource('complain', 'ComplainController');

Route::get('/salary/data', 'DataController@salaries')->name('salary.data');
Route::resource('salary', 'SalaryController');
Route::get('salary/print/{id}', 'SalaryController@print')->name("salary.print");
Route::get("/salary/create/next", "SalaryController@getEmployeeData")->name("salary.employee");

Route::get('/benefit/data', 'DataController@benefits')->name('benefit.data');
Route::resource('benefit', 'BenefitController');
Route::put("/benefit/updateajax/{id}", 'BenefitController@updateAjax');
Route::delete("/benefit/deleteajax/{id}", 'BenefitController@deleteAjax');


Route::get('/report/salary', 'ReportController@salary')->name('report.salary');
Route::get('/report/salary/print', 'ReportController@salaryPrint')->name('report.salary.print');
Route::get('/report/salary/autocomplete', 'ReportController@autocomplete')->name('report.autocomplete');

// get notification
Route::get('/notification/data', 'DataController@notifications')->name('notification.check');
// post notification
Route::post('/notification/generate', 'DataController@generateNotifications')->name('notification.generate');

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home')->middleware('verified');

app/Salary.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Salary extends Model
{
    protected $guarded = [];

    public function bonuses()
    {
        return $this->hasMany(Bonus::class, "salary_id");
    }

    public function employee()
    {
        return $this->belongsTo(Employees::class, "employee_id");
    }
}

app/Http/Controllers/Admin/SalaryController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Bonus;
use App\Employees;
use App\Http\Controllers\Controller;
use App\Salary;
use Carbon\Carbon;
use Illuminate\Database\QueryException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\DB;

class SalaryController extends Controller
{

    public function __construct()
    {
        $this->middleware("permission:create salary")->only(["create", "store"]);
        $this->middleware("permission:read salary")->only(["index", "print"]);
        $this->middleware("permission:update salary")->only(["edit", "update"]);
        $this->middleware("permission:delete salary")->only(["destroy"]);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view("admin.salary.index", [
            'title' => 'Penggajian | Techpolitan'
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view("admin.salary.create", [
            'title' => 'Penggajian | Techpolitan',
            'employees' => Employees::all()
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'employee_id' => 'required',
            'total' => 'required|numeric',
            'date' => 'date|required',
            'benefit_names' => "array|min:1",
            'benefit_amounts' => "array|min:1",
            'benefit_names.*' => "min:3",
            'benefit_amounts.*' => "numeric",
        ]);


        try {
            DB::beginTransaction();

            $salary = Salary::create([
                'employee_id' => $request->employee_id,
                'month' => $request->date
            ]);

            if (!is_null($request->benefit_names)) {
                $bonuses = array_map(function ($name, $amount) {
                    return new Bonus(["name" => $name, "amount" => $amount]);
                }, $request->benefit_names, $request->benefit_amounts);

                $salary->bonuses()->saveMany($bonuses);
            }

            DB::commit();
        } catch (QueryException $e) {
            dd($e);
            DB::rollBack();
            return redirect()->route('admin.salary.index')->with('danger', 'Data Gagal Ditambah');
        }

        return redirect()->route('admin.salary.index')->with('success', 'Data Berhasil Ditambah');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
    }

    public function getEmployeeData(Request $request)
    {
        $employee = Employees::Find($request->id);
        $date = Carbon::parse($request->date);
        // dd($request->date);
        $sick = $employee->attendances()->where([
            [DB::raw("month(time)"), "=", $date->month],
            [DB::raw("year(time)"), "=", $date->year],
            ["description", "=", "sakit"]
        ])->orWhere("description", "izin")->count();
        $attend = $employee->totalAttend($date->month, $date->year);
        $absent = 22 - $attend;
        $late = $employee->totalLate($date->month, $date->year);
        $totalBenefits = array_reduce($employee->group->benefit()->pluck("amount")->toArray(), function ($carry, $item) {
            $carry += $item;
            return $carry;
        });

        $total = (round($attend / 22)) * $employee->salary + $totalBenefits - (($late * 15000));

        return view("admin.salary.create", [
            'title' => 'Penggajian | Techpolitan',
            'employees' => Employees::all(),
            'employee' => $employee,
            'sick' => $sick,
            'late' => $late,
            'absent' => $absent,
            'total' => $total,
            'date' => $request->date
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Salary $salary)
    {
        try {
            DB::beginTransaction();
            Bonus::where("salary_id", $salary->id)->delete();
            $salary->delete();
            DB::commit();
        } catch (QueryException $e) {
            DB::rollBack();
            return redirect()->route('admin.salary.index')->with('danger', 'Data Gagal Didelete');
        }
        return redirect()->route('admin.salary.index')->with('success', 'Data Berhasil Didelete');
    }

    public function print($id)
    {
        $salary = Salary::Find($id);
        $employee = $salary->employee;
        $date = Carbon::parse($salary->month);

        $sick = $employee->attendances()->where([
            [DB::raw("month(time)"), "=", $date->month],
            [DB::raw("year(time)"), "=", $date->year],
            ["description", "=", "sakit"]
        ])->orWhere("description", "izin")->count();
        $attend = $employee->totalAttend($date->month, $date->year);
        $absent = 22 - $attend;
        $late = $employee->totalLate($date->month, $date->year);
        $totalBenefits = array_reduce($employee->group->benefit()->pluck("amount")->toArray(), function ($carry, $item) {
            $carry += $item;
            return $carry;
        });

        // dd($salary->bonuses->toArray());

        if($salary->bonuses->count() > 0) {
            $bonuses = array_map(function ($g, $p) {
                $c3 = isset($p[0]) ? $p[0] : "";
                $c4 = isset($p[1]) ? $p[1] : "";
                return [$g["name"], $g["amount"], $c3, $c4];
            }, $salary->bonuses->toArray(), 
            [["Potongan Absen", $employee->salary - ((round($attend / 22)) * $employee->salary)]] 
        );
        } else {
            $bonuses = [["","","Potongan Absen", $employee->salary - ((round($attend / 22)) * $employee->salary)]];
        }
       
        

        $dataTables = [
            ["Gaji", $employee->salary, "Potongan Terlambat", $late * 15000]
        ];
        $dataTables = array_merge($dataTables, $bonuses);
        $total = (round($attend / 22)) * $employee->salary + $totalBenefits - (($late * 15000)) + (array_sum(array_column($bonuses, 1)));



        $view = view("pdf.slip-gaji", [
            "dataTables" => $dataTables,
            "employee" => $employee,
            "nett" => $total,
            "totalGaji" => (round($attend / 22)) * $employee->salary + $totalBenefits,
            "totalPotongan" => ($employee->salary - ((round($attend / 22)) * $employee->salary)) + (($late * 15000)),
            "date" => Carbon::parse($salary->month)
        ]);

        $pdf = App::make('dompdf.wrapper');
        $pdf->loadHTML($view->render());
        return $pdf->stream();
    }
}

resources/views/admin/salary/action.blade.php
<a href="{{ route('admin.salary.print', $model) }}" class="btn btn-success">Cetak Slip Gaji</a>

@can('delete salary')
<button href="{{ route('admin.salary.destroy', $model) }}" class="btn btn-danger" id="delete"><i class="fa fa-trash"></i></button>
@endcan
<script src="https://cdn.jsdelivr.net/npm/sweetalert2@9"></script>
<script>
    $('button#delete').on('click', function(e){
        e.preventDefault();

        var href = $(this).attr('href');

        Swal.fire({
        title: 'Apakah Yakin Hapus Data?',
        text: "Data yang sudah dihapus tidak bisa dikembalikan !",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Hapus'
        }).then((result) => {
        if (result.value) {

            document.getElementById('deleteForm').action = href;
            document.getElementById('deleteForm').submit();

            Swal.fire(
            'Terhapus',
            'Data kamu berhasil dihapus',
            'success'
            )
        }
    })

    })
</script>

resources/views/admin/salary/create.blade.php
@extends('admin.template.default')

@section('content')

<section class="content-header">
    <h1>
      Gaji & Tunjangan <small>Tambah Data</small>
    </h1>
    <ol class="breadcrumb">
    <li><a href="{{ route('admin.dashboard') }}"><i class="fa fa-dashboard"></i> Home</a></li>
    <li><a href="{{ route('admin.benefit.index') }}"></i> Gaji & Tunjangan</a></li>
      <li class="active">Tambah Data Gaji & Tunjangan</li>
    </ol>
  </section>

<section class="content">
    <div class="row">
        <div class="col-md-12">
            <!-- Horizontal Form -->
            <div class="box box-info">
            <div class="box-header with-border">
                <h3 class="box-title">Tambah Data Gaji & Tunjangan</h3>
            </div>
            <!-- /.box-header -->
            <!-- form start -->

            <form class="form-horizontal" action="{{ route('admin.salary.employee')}}" method="GET">
                @csrf
                <div class="box-body">
                    <div class="form-group @error('name') has-error @enderror">
                        <label for="" class="col-sm-2 control-label">Nama Karyawan</label>

                        <div class="col-sm-4">
                            <select name="id" class="form-control select2">
                            @foreach ($employees as $emp)
                                <option value="{{ $emp->id }}">{{ $emp->name }}</option>
                            @endforeach
                            </select>
                            @error('id')
                                <span class="help-block">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                </div>

                <div class="box-body">
                    <div class="form-group @error('date') has-error @enderror">
                        <label for="" class="col-sm-2 control-label">Bulan</label>

                        <div class="col-sm-4">
                            <div class="input-group date">
                                <div class="input-group-addon">
                                    <i class="fa fa-calendar"></i>
                                </div>
                                <input type="text" name="date" readonly class="form-control pull-right" id="datepicker">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="box-footer">
                    <button type="submit" class="btn btn-info">Tampilkan Karyawan</button>
                </div>
            </form>

            @if (isset($employee))
                <form class="form-horizontal" action="{{ route('admin.salary.store')}}" method="POST">
                    @csrf

                    <div class="box-body">
                        <div class="form-group @error('employee_id') has-error @enderror">
                            <input type="hidden" name="employee_id" value="{{$employee->id}}" />
                            <input type="hidden" name="date" value="{{$date}}" />
                            <label for="" class="col-sm-2 control-label">Nama Karyawan</label>

                            <div class="col-sm-4">
                                <input type="text" class="form-control" readonly name="name" value="{{$employee->name}}" />
                                @error('name')
                                    <span class="help-block">{{ $message }}</span>
                                @enderror
                            </div>
                        </div>
                    </div>

                    <div class="box-body">
                        <div class="form-group @error('salary') has-error @enderror">
                            <label for="" class="col-sm-2 control-label">Gaji Pokok</label>

                            <div class="col-sm-4">
                                <div class="input-group">
                                    <div class="input-group-addon">
                                        Rp
                                    </div>
                                    <input type="text" class="form-control" readonly name="salary" value="{{preg_replace("/(\d)(?=(\d{3})+(?!\d))/", "$1.", $employee->salary)}}" />
                                </div>
                                @error('salary')
                                    <span class="help-block">{{ $message }}</span>
                                @enderror
                            </div>
                        </div>
                    </div>

                    <div class="box-body">
                        <div class="form-group @error('sick') has-error @enderror">
                            <label for="" class="col-sm-2 control-label">Izin atau Sakit</label>

                            <div class="col-sm-4">
                                <input type="text" class="form-control" readonly name="sick" value="{{$sick}}" />
                                @error('sick')
                                    <span class="help-block">{{ $message }}</span>
                                @enderror
                            </div>
                        </div>
                    </div>

                    <div class="box-body">
                        <div class="form-group @error('late') has-error @enderror">
                            <label for="" class="col-sm-2 control-label">Terlambat</label>

                            <div class="col-sm-4">
                                <input type="text" class="form-control" readonly name="late" value="{{$late}}" /> x Rp 15.000
                                @error('late')
                                    <span class="help-block">{{ $message }}</span>
                                @enderror
                            </div>
                        </div>
                    </div>

                    <div class="box-body">
                        <div class="form-group @error('absent') has-error @enderror">
                            <label for="" class="col-sm-2 control-label">Tanpa Keterangan</label>

                            <div class="col-sm-4">
                                <input type="text" class="form-control" readonly name="absent" value="{{$absent}}" />
                                @error('absent')
                                    <span class="help-block">{{ $message }}</span>
                                @enderror
                            </div>
                        </div>
                    </div>

                    <div class="box-body">
                        <div class="form-group @error('norek') has-error @enderror">
                            <label for="" class="col-sm-2 control-label">No. Rekening</label>

                            <div class="col-sm-4">
                                <input type="text" class="form-control" readonly name="norek" value="{{$employee->norek}}" />
                                @error('norek')
                                    <span class="help-block">{{ $message }}</span>
                                @enderror
                            </div>
                        </div>
                    </div>

                    <div class="box-body">
                        <div class="form-group @error('type') has-error @enderror">
                            <label for="" class="col-sm-2 control-label">Tunjangan</label>
                            <div class="row col-sm-8">
                                @foreach ($employee->group->benefit as $benefit)
                                    <div class="row">
                                        <div class="col-md-3">
                                            <input type="hidden"  class="benefitId" value="{{$benefit->id}}" />
                                            <input class="form-control" readonly type="text" class="form-control" placeholder="Nama Tunjangan" value="{{$benefit->name}}" />
                                        </div>
                                        <div class="col-md-1">
                                            -
                                        </div>
                                        <div class="col-md-4">
                                            <div class="input-group">
                                                <div class="input-group-addon">
                                                    Rp
                                                </div>
                                                <input class="form-control" readonly type="number" class="form-control" placeholder="Nominal (Rp)" value="{{preg_replace("/(\d)(?=(\d{3})+(?!\d))/", "$1.", $benefit->amount)}}" />
                                            </div>
                                        </div>
                                    </div>
                                @endforeach
                            </div>
                        </div>
                    </div>

                    <div class="box-body">
                        <div class="col-md-8 col-md-offset-2">
                            <button id="btnBenefitAdd" class="btn btn-primary">Tambah Tunjangan <i class="fa fa-plus"></i></button>
                            <div class="row" id="benefitLists">
                            </div>
                        </div>
                    </div>

                    <div class="box-body">
                        <div class="form-group @error('total') has-error @enderror">
                            <label for="" class="col-sm-2 control-label">Total</label>

                            <div class="col-sm-10">
                                <input type="hidden" id="subtotal" value="{{$total}}" />
                                <input type="hidden" id="total" name="total" value="{{$total}}" />
                                <div class="input-group">
                                    <div class="input-group-addon">
                                        Rp
                                    </div>
                                    <input type="text" class="form-control" id="totalDisp" readonly value="{{preg_replace("/(\d)(?=(\d{3})+(?!\d))/", "$1.", $total)}}" />
                                </div>
                                @error('total')
                                    <span class="help-block">{{ $message }}</span>
                                @enderror
                            </div>
                        </div>
                    </div>

                    </div>
                    </div>
                    <!-- /.box-body -->
                    <div class="box-footer">
                        <button type="submit" class="btn btn-info">Tambah Data</button>
                    </div>
                    <!-- /.box-footer -->
                </form>
            @endif
            </div>
            <!-- /.box -->
        </div>
    </div>
</section>
@endsection

@push("script")
    <script src="{{ asset('admin/plugins/bs-notify.min.js') }}"></script>
    <script src="{{ asset('admin/bower_components/bootstrap-datepicker/dist/js/bootstrap-datepicker.min.js') }}"></script>
    <script src="{{ asset('admin/bower_components/moment/min/moment.min.js') }}"></script>
    <script type="text/javascript">
        $(document).ready(() => {
            $("#datepicker").datepicker({
                format: 'yyyy-mm-dd'
            });

            $("#btnBenefitAdd").on("click", (e) => {
                e.preventDefault();
                let list = `
                <div class="row">
                    <div class="col-md-5">
                        <input type="text" name="benefit_names[]" class="form-control" placeholder="Nama Tunjangan">
                    </div>
                    <div class="col-md-1">
                        -
                    </div>
                    <div class="col-md-5">
                        <input type="number" name="benefit_amounts[]" class="form-control" placeholder="Nominal (Rp)">
                    </div>
                    <div class="col-md-1">
                        <a href="#" class="btn btn-danger btnDelete">x</a>
                    </div>
                </div>`;
                $("#benefitLists").append(list);
            });

            $("form").on("keyup", "input[name='benefit_amounts[]']", (e) => {
                let benefits = Array.from($("form input[name='benefit_amounts[]']")).map(e => parseInt(e.value)).reduce((p, c) => p+c, 0);
                let total = benefits+parseInt($("#subtotal").val());
                $("#total").val(total);
                $("#totalDisp").val(total.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1."));
            });

            $("#benefitLists").on("click", ".row .col-md-1 a.btnDelete", (e) => {
                $(e.target).parent(".col-md-1").parent(".row").remove();
            });
        });
    </script>
@endpush

resources/views/admin/salary/edit.blade.php
@extends('admin.template.default')

@section('content')

<section class="content-header">
    <h1>
      Gaji & Tunjangan  <small>Update Data</small>  
    </h1>
    <ol class="breadcrumb">
    <li><a href="{{ route('admin.dashboard') }}"><i class="fa fa-dashboard"></i> Home</a></li>
      <li class="active"><a href="{{ route('admin.benefit.index') }}">Gaji & Tunjangan</a></li>
      <li class="active">Update Gaji & Tunjangan</li>
    </ol>
  </section>

<section class="content">
    <div class="row">
        <div class="col-md-12">
            <!-- Horizontal Form -->
            <div class="box box-info">
            <div class="box-header with-border">
                <h3 class="box-title">Update Data Gaji & Tunjangan</h3>
            </div>
            <!-- /.box-header -->
            <!-- form start -->
            <form class="form-horizontal" action="{{ route('admin.benefit.update', $benefit)}}" method="POST">
                @csrf
                @method("PUT")

                <div class="box-body">
                    <div class="form-group @error('employee_id') has-error @enderror">
                        <label class="col-sm-2 control-label">Nama Karyawan</label>

                        <div class="col-sm-10">
                            <select name="employee_id" class="form-control select2">
                                @foreach ($employees as $employee)
                                    <option 
                                        value="{{ $employee->id }}"
                                        @if ($employee->id === $benefit->employee_id)
                                            selected
                                        @endif
                                        >
                                        {{ $employee->name }}
                                    </option>
                                @endforeach
                            </select>
                            @error('employee_id')
                                <span class="help-block">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                </div>

                <div class="box-body">
                    <div class="form-group @error('categorie_id') has-error @enderror">
                        <label class="col-sm-2 control-label">Kategori</label>

                        <div class="col-sm-10">
                            <select name="categorie_id" class="form-control select2">
                                @foreach ($categories as $categorie)
                                    <option 
                                        value="{{ $categorie->id }}"
                                        @if ($categorie->id === $benefit->categorie_id)
                                            selected
                                        @endif
                                        >
                                        {{ $categorie->name }}
                                    </option>
                                @endforeach
                            </select>
                            @error('categorie_id')
                                <span class="help-block">{{ $message }}</span>
                            @enderror
                        </div>                    
                    </div>
                </div>

                <div class="box-body">
                    <div class="form-group @error('nominal') has-error @enderror">
                        <label for="" class="col-sm-2 control-label">Nominal</label>

                        <div class="col-sm-10">
                            <input type="text" class="form-control" name="nominal" placeholder="Jenis Kelamin" value="{{ old('nominal') ?? $benefit->nominal }}">
                            @error('nominal')
                                <span class="help-block">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                </div>

                <div class="box-body">
                    <div class="form-group @error('status') has-error @enderror">
                        <label for="" class="col-sm-2 control-label">Status</label>

                        <div class="col-sm-10">
                            <select name="status" class="form-control select2">
                                <option value="Aktif">Aktif</option>
                                <option value="Tidak aktif  ">Tidak Aktif</option>
                            </select>
                            @error('status')
                                <span class="help-block">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                </div>
                
                <!-- /.box-body -->
                <div class="box-footer">
                <button type="submit" class="btn btn-info">Update Data</button>
                </div>
                <!-- /.box-footer -->
            </form>
            </div>
            <!-- /.box -->
        </div>
    </div>
</section>
@endsection